# Installing PsychOS

## Step 0: Information
PsychOS requires the following hardware:

- 150K RAM
- 40K storage, preferably on its own disk

In addition, this guide assumes the machine has an internet card to download files with. It's possible to install PsychOS from an existing copy but that is out of scope of this guide.

You will want to know the address of the disk you plan to install PsychOS onto.

### Useful key combinations:
`ctrl-shift-c` inside PsychOS will cancel text input or stop certain programs.

`ctrl-shift-r` will soft-reboot the machine, preserving the content of `/tmp`.

## Step 1: Obtaining and booting a copy of PsychOS
From OpenOS:

```
cd /tmp  
wget https://oc.shadowkat.net/PsychOS/build/fsdev/PsychOS-fsdev-latest/severything.lua init.lua  
init.lua
```

If you are unable to donload the file, try http rather than https.
The 'same file' error is normal.

These commands will reboot your machine into PsychOS running from the computer's temporary filesystem. Following this, you should see something like

```
PsychOS 83e2673 on 404cf459,  256K memory  
lush v1/Lua 5.2  
[superuser@404cf459 /boot]#
```

## Step 2: Downloading to a disk
From your prompt, you'll want to invoke pkg to download a copy of PsychOS onto a disk. The path of the disk is `/<the first 3 characters of the disk address>/`  
You can also use /tmp/ if you want a full live system. At present this uses about 50k out of the 64k available on /tmp/

```
[superuser@404cf459 /boot]# pkg install https://oc.shadowkat.net/PsychOS/build/fsdev/PsychOS-fsdev-latest/psychos-latest.pkr /<disk>/
```

This will take a while, but will output progress.

If the machine hangs, use the http version of the recipe file:

```
http://oc.shadowkat.net/PsychOS/build/fsdev/PsychOS-fsdev-latest/psychos-latest-http.pkr
```

Once that has completed, power your machine off and take out all but the disk you installed PsychOS onto, then boot it up.

## Step 3: Configuration
This step is optional.

Now that you have a working PsychOS system, you can set up users.

### superuser
Superuser is the most powerful user on the system, and should have a strong password.

```
[superuser@404cf459 /boot]# passwd superuser  
New password for superuser: ********
```

### A non-superuser
Running as superuser all the time is bad for security, so you should create a user for yourself.
```
[superuser@404cf459 /boot]# passwd username  
New password for username: ********
```

Now, if you press ctrl-alt-c, it should bring up a login screen.

Congratulations, you now have a functional and configured PsychOS system.
